3 # Copyright (c) 2005 Junio C Hamano
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
10 # do not redirect again
12 *' --tee '*|
*' --va'*)
14 BASE
=test-results
/$
(basename "$0" .sh
)
15 (GIT_TEST_TEE_STARTED
=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $?
> $BASE.
exit) |
tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
22 # Keep the original TERM for say_color
25 # For repeatability, reset the environment to known value.
31 export LANG LC_ALL PAGER TERM TZ
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
43 GIT_AUTHOR_EMAIL
=author@example.com
44 GIT_AUTHOR_NAME
='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL
=committer@example.com
47 GIT_COMMITTER_NAME
='C O Mitter'
51 unset GIT_EXTERNAL_DIFF
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
62 GIT_TEST_CMP
=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
68 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
70 echo "* warning: Some tests will not work if GIT_TRACE" \
71 "is set as to trace on STDERR ! *"
72 echo "* warning: Please set GIT_TRACE to something" \
73 "other than 1, 2 or true ! *"
77 # Each test should start with something like this, after copyright notices:
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84 TERM
=$ORIGINAL_TERM &&
87 tput bold
>/dev
/null
2>&1 &&
88 tput setaf
1 >/dev
/null
2>&1 &&
89 tput sgr0
>/dev
/null
2>&1
96 -d|
--d|
--de|
--deb|
--debu|
--debug)
98 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
100 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
101 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
102 -h|
--h|
--he|
--hel|
--help)
104 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
106 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
113 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
114 valgrind
=t
; verbose
=t
; shift ;;
116 shift ;; # was handled already
122 if test -n "$color"; then
128 error
) tput bold
; tput setaf
1;; # bold red
129 skip
) tput bold
; tput setaf
2;; # bold green
130 pass
) tput setaf
2;; # green
131 info
) tput setaf
3;; # brown
132 *) test -n "$quiet" && return;;
142 test -z "$1" && test -n "$quiet" && return
149 say_color error
"error: $*"
158 test "${test_description}" != "" ||
159 error
"Test script did not set test_description."
161 if test "$help" = "t"
163 echo "$test_description"
168 if test "$verbose" = "t"
172 exec 4>/dev
/null
3>/dev
/null
182 echo >&5 "FATAL: Unexpected exit with code $?"
188 # The semantics of the editor variables are that of invoking
189 # sh -c "$EDITOR \"$@\"" files ...
191 # If our trash directory contains shell metacharacters, they will be
192 # interpreted if we just set $EDITOR directly, so do a little dance with
193 # environment variables to work around this.
195 # In particular, quoting isn't enough, as the path may contain the same quote
200 VISUAL
='"$FAKE_EDITOR"'
205 if test -z "${test_tick+set}"
209 test_tick
=$
(($test_tick + 60))
211 GIT_COMMITTER_DATE
="$test_tick -0700"
212 GIT_AUTHOR_DATE
="$test_tick -0700"
213 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
216 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
218 # This will commit a file with the given contents and the given commit
219 # message. It will also add a tag with <message> as name.
221 # Both <file> and <contents> default to <message>.
225 echo "${3-$1}" > "$file" &&
228 git commit
-m "$1" &&
232 # Call test_merge with the arguments "<message> <commit>", where <commit>
233 # can be a tag pointing to the commit-to-merge.
237 git merge
-m "$1" "$2" &&
241 # This function helps systems where core.filemode=false is set.
242 # Use it instead of plain 'chmod +x' to set or unset the executable bit
243 # of a file in the working directory and add it to the index.
247 git update-index
--add "--chmod=$@"
250 # You are not expected to call test_ok_ and test_failure_ directly, use
251 # the text_expect_* functions instead.
254 test_success
=$
(($test_success + 1))
255 say_color
"" " ok $test_count: $@"
259 test_failure
=$
(($test_failure + 1))
260 say_color error
"FAIL $test_count: $1"
262 echo "$@" |
sed -e 's/^/ /'
263 test "$immediate" = "" ||
{ trap - EXIT
; exit 1; }
266 test_known_broken_ok_
() {
267 test_fixed
=$
(($test_fixed+1))
268 say_color
"" " FIXED $test_count: $@"
271 test_known_broken_failure_
() {
272 test_broken
=$
(($test_broken+1))
273 say_color skip
" still broken $test_count: $@"
277 test "$debug" = "" ||
eval "$1"
287 test_count
=$
(($test_count+1))
289 for skp
in $GIT_SKIP_TESTS
291 case $this_test.
$test_count in
298 say_color skip
>&3 "skipping test: $@"
299 say_color skip
"skip $test_count: $1"
308 test_expect_failure
() {
310 error
"bug in the test script: not 2 parameters to test-expect-failure"
313 say
>&3 "checking known breakage: $2"
315 if [ "$?" = 0 -a "$eval_ret" = 0 ]
317 test_known_broken_ok_
"$1"
319 test_known_broken_failure_
"$1"
325 test_expect_success
() {
327 error
"bug in the test script: not 2 parameters to test-expect-success"
330 say
>&3 "expecting success: $2"
332 if [ "$?" = 0 -a "$eval_ret" = 0 ]
342 test_expect_code
() {
344 error
"bug in the test script: not 3 parameters to test-expect-code"
347 say
>&3 "expecting exit code $1: $3"
349 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
359 # test_external runs external test scripts that provide continuous
360 # test output about their progress, and succeeds/fails on
361 # zero/non-zero exit code. It outputs the test output on stdout even
362 # in non-verbose mode, and announces the external script with "* run
363 # <n>: ..." before running it. When providing relative paths, keep in
364 # mind that all scripts run in "trash directory".
365 # Usage: test_external description command arguments...
366 # Example: test_external 'Perl API' perl ../path/to/test.pl
369 error
>&5 "bug in the test script: not 3 parameters to test_external"
372 if ! test_skip
"$descr" "$@"
374 # Announce the script to reduce confusion about the
375 # test output that follows.
376 say_color
"" " run $test_count: $descr ($*)"
377 # Run command; redirect its stderr to &4 as in
378 # test_run_, but keep its stdout on our stdout even in
385 test_failure_
"$descr" "$@"
390 # Like test_external, but in addition tests that the command generated
391 # no output on stderr.
392 test_external_without_stderr
() {
393 # The temporary file has no (and must have no) security
395 tmp
="$TMPDIR"; if [ -z "$tmp" ]; then tmp
=/tmp
; fi
396 stderr
="$tmp/git-external-stderr.$$.tmp"
397 test_external
"$@" 4> "$stderr"
398 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
399 descr
="no stderr: $1"
401 say
>&3 "expecting no stderr from previous command"
402 if [ ! -s "$stderr" ]; then
406 if [ "$verbose" = t
]; then
407 output
=`echo; echo Stderr is:; cat "$stderr"`
411 # rm first in case test_failure exits.
413 test_failure_
"$descr" "$@" "$output"
417 # This is not among top-level (test_expect_success | test_expect_failure)
418 # but is a prefix that can be used in the test script, like:
420 # test_expect_success 'complain and die' '
422 # do something else &&
423 # test_must_fail git checkout ../outerspace
426 # Writing this as "! git checkout ../outerspace" is wrong, because
427 # the failure could be due to a segv. We want a controlled failure.
431 test $?
-gt 0 -a $?
-le 129 -o $?
-gt 192
434 # test_cmp is a helper function to compare actual and expected output.
435 # You can use it like:
437 # test_expect_success 'foo works' '
438 # echo expected >expected &&
440 # test_cmp expected actual
443 # This could be written as either "cmp" or "diff -u", but:
444 # - cmp's output is not nearly as easy to read as diff -u
445 # - not all diff versions understand "-u"
451 # Most tests can use the created repository, but some may need to create more.
452 # Usage: test_create_repo <directory>
453 test_create_repo
() {
455 error
"bug in the test script: not 1 parameter to test-create-repo"
459 cd "$repo" || error
"Cannot setup test environment"
460 "$GIT_EXEC_PATH/git-init" "--template=$owd/../templates/blt/" >&3 2>&4 ||
461 error
"cannot run git init -- have you built things yet?"
462 mv .git
/hooks .git
/hooks-disabled
468 test_results_dir
="$TEST_DIRECTORY/test-results"
469 mkdir
-p "$test_results_dir"
470 test_results_path
="$test_results_dir/${0%.sh}-$$"
472 echo "total $test_count" >> $test_results_path
473 echo "success $test_success" >> $test_results_path
474 echo "fixed $test_fixed" >> $test_results_path
475 echo "broken $test_broken" >> $test_results_path
476 echo "failed $test_failure" >> $test_results_path
477 echo "" >> $test_results_path
479 if test "$test_fixed" != 0
481 say_color pass
"fixed $test_fixed known breakage(s)"
483 if test "$test_broken" != 0
485 say_color error
"still have $test_broken known breakage(s)"
486 msg
="remaining $(($test_count-$test_broken)) test(s)"
488 msg
="$test_count test(s)"
490 case "$test_failure" in
493 # cd .. && rm -fr 'trash directory'
494 # but that means we forbid any tests that use their own
495 # subdirectory from calling test_done without coming back
496 # to where they started from.
497 # The Makefile provided will clean this test area so
498 # we will leave things as they are.
500 say_color pass
"passed all $msg"
502 test -d "$remove_trash" &&
503 cd "$(dirname "$remove_trash")" &&
504 rm -rf "$(basename "$remove_trash")"
509 say_color error
"failed $test_failure among $msg"
515 # Test the binaries we have just built. The tests are kept in
516 # t/ subdirectory and are run in 'trash directory' subdirectory.
517 TEST_DIRECTORY
=$
(pwd)
518 if test -z "$valgrind"
520 if test -z "$GIT_TEST_INSTALLED"
522 PATH
=$TEST_DIRECTORY/..
:$PATH
523 GIT_EXEC_PATH
=$TEST_DIRECTORY/..
525 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
526 error
"Cannot run git from $GIT_TEST_INSTALLED."
527 PATH
=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..
:$PATH
528 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
533 test "$1" = "$(readlink "$2")" ||
{
541 while test -d "$2".lock
543 say
"Waiting for lock on $2."
550 make_valgrind_symlink
() {
551 # handle only executables
552 test -x "$1" ||
return
554 base
=$
(basename "$1")
555 symlink_target
=$TEST_DIRECTORY/..
/$base
556 # do not override scripts
557 if test -x "$symlink_target" &&
558 test ! -d "$symlink_target" &&
559 test "#!" != "$(head -c 2 < "$symlink_target")"
561 symlink_target
=..
/valgrind.sh
565 symlink_target
=..
/unprocessed-script
567 # create the link, or replace it if it is out of date
568 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
571 # override all git executables in TEST_DIRECTORY/..
572 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
573 mkdir
-p "$GIT_VALGRIND"/bin
574 for file in $TEST_DIRECTORY/..
/git
* $TEST_DIRECTORY/..
/test-
*
576 make_valgrind_symlink
$file
582 ls "$path"/git-
* 2> /dev
/null |
585 make_valgrind_symlink
"$file"
589 PATH
=$GIT_VALGRIND/bin
:$PATH
590 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
593 GIT_TEMPLATE_DIR
=$
(pwd)/..
/templates
/blt
595 GIT_CONFIG_NOSYSTEM
=1
596 GIT_CONFIG_NOGLOBAL
=1
597 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
599 GITPERLLIB
=$
(pwd)/..
/perl
/blib
/lib
:$
(pwd)/..
/perl
/blib
/arch
/auto
/Git
601 test -d ..
/templates
/blt ||
{
602 error
"You haven't built things yet, have you?"
605 if ! test -x ..
/test-chmtime
; then
606 echo >&2 'You need to build test-chmtime:'
607 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
611 . ..
/GIT-BUILD-OPTIONS
614 test="trash directory.$(basename "$0" .sh)"
615 test ! -z "$debug" || remove_trash
="$TEST_DIRECTORY/$test"
618 echo >&5 "FATAL: Cannot prepare test area"
622 test_create_repo
"$test"
623 # Use -P to resolve symlinks in our working directory so that the cwd
624 # in subprocesses like git equals our $PWD (for pathname comparisons).
625 cd -P "$test" ||
exit 1
628 this_test
=${this_test%%-*}
629 for skp
in $GIT_SKIP_TESTS
632 for skp
in $GIT_SKIP_TESTS
641 say_color skip
>&3 "skipping test $this_test altogether"
642 say_color skip
"skip all tests in $this_test"